function E=domo_predict(I,D,varargin);

% function E=domo_predict(I,D,varargin);
% 
% Perform a prediction using the Domo method.  I is a problem instance
% and D a distance matrix (potentially noisy).  Additional options
% will be passed on to objective_predict.m (which uses active_set.m
% and convex_iter.m).  See those files for descriptions of the
% options.  A structure is returned with a number of field filled.
% The resulting predicted gram matrix is returned vectorized in the
% field E.x

Ir = reduce_instance(I);
In = instance_noise(dist2gram(D),Ir); 
R = obj_design_fixed(In); 
E = objective_predict(I, R.cL, 'frac',0.30, varargin{:});
E.obj = D;
E.R = R;
E.data = {R.cL};

E.totaltime = E.totaltime + R.totaltime;
