function In=instance_noise(Gn,I,varargin)
% function I=instance_noise(Gn,I,varargin)
% Adjust instance I for new gram matrix Gn which has noise added 
zerodist=1e-1;

if I.full
  fprintf('Only use this function with reduced instances for design\n')
  In=[];
  return;
end

In = I;

xS=mat2svec(Gn);
ASin = I.AS(~I.iseq,:);
bin = I.b(~I.iseq);

xL = ASin*xS - bin;
fprintf('Ignoring %d violated inequality constr\n',length(find(xL<0)));
xL(xL<=zerodist) = 0;
zLidx = find(xL==0);
nzL = length(zLidx);
In.nzL = nzL;
In.Ibar = sparse(zLidx,1:nzL,ones(nzL,1),I.n_in,nzL);

[q ll]=eig(Gn);
l=diag(ll);
fprintf('Zeroing %d eigenvalues\n',length(find(l<0)));
l(l<0) = 0;
for i=1:I.nb-3
  QQ(:,i) = mat2svec(q(:,i)*q(:,i)');
end
In.QQ = QQ;

In.xL = xL;
In.x = [xL; xS];
