function [cc]=linear2sdpobj(c,A,K)
% Move the linear objective to the semidefinite objective

[cL cS]=separate(c,K);
[AL AS]=separate(A,K);
cc=cS;

[rows cols] = find(AL);
colmat = spdiags(cL(cols),0,K.l,K.l);
cc = cc + sum(AS(rows,:)'*colmat,2);

cc=[sparse(K.l,1);cc];

% Old slow method
% for col=1:K.l
%   row = find(AL(:,col)~=0);
%   if length(row)>1, fprintf('Warning: cL term %d appears in multiple constraints\n',i); end
%   adj=cL(col)*AS(row,:)';
%   cc=cc+adj;
% end
