function X=svec2mat(v,scale)

% function X=svec2mat(v,scale)
%
% Convert a symmetric vector representation to a symmetric matrix, uses
% diagonal ordering, scale=1/sqrt(2) by default to preserve inner products

if nargin<2 || scale==0, scale=1/sqrt(2); end
l=length(v);
% Calculate size of matrix
n = (1+sqrt(1+8*l))/2 -1;
idx=1;

X=diag(v(1:n),0);
idx=n;
for i=1:n-1
  X=X+diag(v(idx+1:idx+n-i),i)*scale;
  idx=idx+n-i;
end
X=X+triu(X,1)';

% else
%   for i=1:n-1
%     X=X+diag(v(idx+1:idx+n-i),i);
%     idx=idx+n-i;
%   end
% end

    
% X=zeros(n);
% for i=1:n
%   X(i:n,i)=v(idx:idx+n-i);
%   X(i,i:n)=v(idx:idx+n-i);
%   if symflag,
%     X(i+1:n,i)=X(i+1:n,i)*r2;
%     X(i,i+1:n)=X(i,i+1:n)*r2;
%   end
%   idx=idx+n-i+1;
% end